---
title: Contributing
has_children: true
nav_order: 10
---

# Contributing

Theodolite is open-source research software. We welcome everyone to contribute to this project.
Contributions are not limited to code contributions, instead we welcome and recognize everything concerning:

* Raising issues, questions and suggestions for using Theodolite
* Fixing bugs or implementing new features
* Improving the documentation
* Using Theodolite as part of your (not necessarily scientific) research
* Reporting on your scalability evaluations with Theodolite

## Start Contributing

If you have bug reports, feature requests, questions or suggestions, you may create a [GitHub issue](https://github.com/cau-se/theodolite/issues) or directly [contact Theodolite's maintainers](../project-info).
You can also create a [GitHub pull request](https://github.com/cau-se/theodolite/pulls) if you have already implemented bug fixes and improvements.

If you would like to get more involved in Theodolite's project development and maintenance, you may contact us as well so we can set you up an account for [our internal GitLab](../project-info#project-management).

## Internal Project Structure

Theodolite is organized as a monorepo containing multiple largely independent modules in subdirectories.
See the project's [`README.md`](https://github.com/cau-se/theodolite/blob/main/README.md#project-structure) for an overview of all modules.
Each module directory provides a dedicated `README.md` file describing how to build, test, package,... the corresponding module.
